'---------------------------------------------------------------------
'  Copyright (C) Microsoft Corporation.  All rights reserved.
' 
' THIS CODE AND INFORMATION ARE PROVIDED AS IS WITHOUT WARRANTY OF ANY
' KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
' IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
' PARTICULAR PURPOSE.
'
'---------------------------------------------------------------------

Option Explicit On
Option Strict On

Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.ComponentModel.Design
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms
Imports System.Windows.Forms.Design.Behavior

Namespace Extensions

    Friend Class AnchorBehavior
        Inherits Behavior

        Public Overrides Function OnMouseDoubleClick( _
            ByVal g As System.Windows.Forms.Design.Behavior.Glyph, _
            ByVal button As System.Windows.Forms.MouseButtons, _
            ByVal mouseLoc As System.Drawing.Point) As Boolean

            MyBase.OnMouseDoubleClick(g, button, mouseLoc)

            If button = MouseButtons.Left Then
                Dim ag As AnchorGlyph = CType(g, AnchorGlyph)
                Dim pdAnchor As PropertyDescriptor = _
                    TypeDescriptor.GetProperties(ag.RelatedControl)("Anchor")

                If ag.IsEnabled Then
                    ' The glyph is enabled. 
                    ' Clear the AnchorStyle flag to disable the Glyph.
                    pdAnchor.SetValue( _
                        ag.RelatedControl, _
                        ag.RelatedControl.Anchor Xor ag.AnchorStyle)
                Else
                    ' The glyph is disabled. 
                    ' Set the AnchorStyle flag to enable the Glyph.
                    pdAnchor.SetValue( _
                        ag.RelatedControl, _
                        ag.RelatedControl.Anchor Or ag.AnchorStyle)
                End If

            End If

            Return True
        End Function

    End Class

End Namespace
